subroutine dfs(imx1,nrow,ncol,header,u,maxdirection)
! subroutine for debris flow simulation
use model_vars;use input_vars; use grids;use input_file_defs;use output_file_defs
use inflow_vars
implicit none
integer:: i,ii,j,k,m,n,nsteps,ncol,nrow,trace,imx1,nt,nq,inflowsize,vv,vvmax,maxdirection
integer:: u(25)
double precision:: tnext
double precision:: tempri(imx1),tempinflowh(imx1),tempinflowrho(imx1)
double precision:: fvpredi(imx1,maxdirection),fvpredi2(imx1,maxdirection),fhpredi(imx1),frhopredi(imx1),cv(imx1),erorate(imx1),deporate(imx1),fhpredi2(imx1),frhopredi2(imx1),fybar(imx1,maxdirection),fq(imx1,maxdirection)
double precision:: sf,sfy,sfmiu,sfmanning,coemiu,coemanning,tao,taoc,grav,normfric,absubar(imx1),normfriccoe,miudebris,gammadeb,rhoero,rhodepo(imx1),manningb,manningm
double precision:: tol
double precision:: hi,hn,grad,ybar,agrad,cvbar,normfriccoebar,miubar,hbar,manningbar,frhobar,frhoflux
double precision:: parai,paran,aa,bb,cc,dd,vel,qq(imx1,maxdirection),qnet,hinflow,cellarea,qqmass(imx1,maxdirection),qmassnet,dttest,dfhtest,dpfhtest,fvlimit,dt0,localvdiff,dv
double precision:: hour,cosslope
character (len=25):: stp
character (len=255):: outfil
character (len=14)::  header(6)
double precision:: totalvolume,totalflowvolume,totaldepositvolume
double precision:: lambdainverse(imx1),fvdepo(imx1),tanthetae,sinthetae,cvlimit(imx1)
double precision:: tempinierodithick(imx1),tempdebdepothick(imx1)
double precision:: artivis
double precision:: width,rholimit(imx1),vx,vy,fhtemp,fvtemp,cvtemp
tempri=0.
cv=0.
grav=9.81
manningb=0.0538
manningm=6.0896
totalvolume=0.
totalflowvolume=0.
totaldepositvolume=0.

! rhoero is the density of the bed
rhoero=cvstar*(rhos-rhow)+rhow
rhodepo=rhoero

! initialize
tempinierodithick=inierodithick
tempdebdepothick=0.

! tol is the minimum flow depth for velocity computation
tol=0.0001

cellarea=celsiz**2.

outflow=.false.
width=celsiz/2.

if (noinflow>0) inflowsize=size(inflowht(noinflow,:))

! main loop
do 1000, nt=1,maxnts

! erorate is the erosion rate
erorate=0.
deporate=0.
fvdepo=0.
rhodepo=rhoero
tnext=tnow+dt
qq=0.
qqmass=0.
fybar=0.


if (tnext<=simul) then

! *****************************************************************
! determine the excessive rainfall intensity of each cell
if (rainsimul) then
do j=1,nper
if (capt(j)<=tnow .and. tnext<=capt(j+1)) then 
tempri(:)=rideb(:,j)
exit
elseif (tnow<=capt(j+1) .and. capt(j+1)<=tnext) then
tempri(:)=((capt(j+1)-tnow)*rideb(:,j)+(tnext-capt(j+1))*rideb(:,j+1))/dt
exit
end if
end do
end if
! *****************************************************************
! determine the information of inflow hydrograph for the needed cell
if (inflowsimul) then
if (noinflow>0) then

do 1010, k=1,noinflow
do i=1,imx1
if (i==inflowcell(k)) then

if (tnow<inflowht(k,inflowsize)) then

do j=1,inflowsize-1

if (inflowht(k,j)<=tnow .and. tnext<=inflowht(k,j+1)) then 
tempinflowh(i)=inflowhq(k,j+1)*dt/cellarea
tempinflowrho(i)=(rhos-rhow)*inflowhcv(k,j+1)+rhow

goto 1010
elseif (tnow<=inflowht(k,j+1) .and. inflowht(k,j+1)<=tnext) then

if (j<=inflowsize-2) then
tempinflowh(i)=((inflowht(k,j+1)-tnow)*inflowhq(k,j+1)+(tnext-inflowht(k,j+1))*inflowhq(k,j+2))/cellarea
tempinflowrho(i)=(rhos-rhow)*inflowhcv(k,j+1)+rhow

goto 1010
else
tempinflowh(i)=(inflowht(k,j+1)-tnow)*inflowhq(k,j+1)/cellarea
tempinflowrho(i)=(rhos-rhow)*inflowhcv(k,j+1)+rhow

goto 1010
end if


goto 1010
end if
end do

else 

tempinflowh(i)=0.
tempinflowrho(i)=0.

end if


end if
end do
1010 continue

end if
end if

if (erosionsimul .or. sepdepositionsimul) then 
vvmax=2
else
vvmax=1
end if


do vv=1,vvmax
fvpredi2=0.5*(fv+fvpredi)
! *****************************************************************
! compute the limit flow velocity for erosion and deposition processes
if (erosionsimul .or. sepdepositionsimul) then 
do i=1,imx1
cv(i)=(frho(i)-rhow)/(rhos-rhow)
cvlimit(i)=rhow*tan(slo(i))/((rhos-rhow)*(tan(phit(zo(i)))-tan(slo(i))))
if (cv(i)<0.) then
write (*,*) 'i',i,'cv<0',cv(i),'frho',frho(i),'fh',fh(i)
!pause
end if

if (isnan(cv(i))) then
write (*,*) 'i',i,'cv is NAN',cv(i),'frho',frho(i),'fh',fh(i)
pause
end if

if (cvlimit(i)<0.15) cvlimit(i)=6.7*cvlimit(i)**2.
if (cvlimit(i)<0..or. cvlimit(i)>1.) cvlimit(i)=cvstar
rholimit(i)=cvlimit(i)*(rhos-rhow)+rhow
! computing the flow velocity for computation of erosion and deposition
vx=(abs(fvpredi2(i,2))+abs(fvpredi2(i,3))+abs(fvpredi2(i,6))+abs(fvpredi2(i,7)))/4.
vy=(abs(fvpredi2(i,4))+abs(fvpredi2(i,5))+abs(fvpredi2(i,8))+abs(fvpredi2(i,1)))/4.
absubar(i)=(vx**2.+vy**2.)**0.5


lambdainverse(i)=(cvstar/cv(i))**0.333-1
tanthetae=(cv(i)*(rhos-rhow)*tan(phit(zo(i))))/(cv(i)*(rhos-rhow)+rhow)
sinthetae=sin(atan(tanthetae))
fvdepo(i)=2./5./d50*(grav*sinthetae*frho(i)/0.02/rhos)**0.5*lambdainverse(i)*fh(i)**1.5

end do
end if

! *****************************************************************
! determine the erosion rate of each cell

if (erosionsimul) then

do i=1,imx1

! cv must be smaller than cvlimit
if (cv(i)<cvlimit(i)) then
normfriccoe=cos(slo(i))**2.*tan(phit(zo(i)))
sfy=(1-cs)*(rhos-rhow)/frho(i)*cv(i)*normfriccoe
gammadeb=frho(i)*grav
if (cv(i)<=0.1) then
miudebris=0.001+cv(i)/0.1*(alpha2*exp(beta2*0.1)-0.001)
else
miudebris=alpha2*exp(beta2*cv(i))
end if
coemiu=kresis*miudebris/8./gammadeb/fh(i)**2.
sfmiu=coemiu*absubar(i)
coemanning=manning(i)**2./fh(i)**1.333
sfmanning=coemanning*absubar(i)**2.
tao=(sfy+sfmiu+sfmanning)*gammadeb*fh(i)
taoc=ct(zo(i))+(1-cs)*cv(i)*(rhos-rhow)*grav*fh(i)*cos(slo(i))**2.*tan(phit(zo(i)))

if (fh(i)>0. .and. tao>taoc) erorate(i)=kero(zo(i))*(tao-taoc)
if (erorate(i)<0.) then
write (*,*) 'i',i,'erorate',erorate(i),'cvlimit',cvlimit(i),'cv',cv(i),'fh',fh(i),'absubar',absubar(i),'cv(i)<cvlimit(i)'
pause 
end if

!if (cv(i)<cvlimit) then
else
cycle
!if (cv(i)<cvlimit) then
end if

! to make sure the cv is not larger than cvlimit due to erosion in one time step

if ((frho(i)*fh(i)+erorate(i)*dt*rhoero)>(rholimit(i)*(fh(i)+erorate(i)*dt))) then
erorate(i)=(rholimit(i)-frho(i))*fh(i)/(rhoero-rholimit(i))/dt
end if

! update the thickness of the initial erodible layer and the deposit layer
if (erorate(i)*dt<=inierodithick(i)) then
tempinierodithick(i)=inierodithick(i)-erorate(i)*dt
else
erorate(i)=(inierodithick(i))/dt
tempinierodithick(i)=0.
end if
!write (*,*) 'i',i,'erorate', erorate(i)

end do 
!if (erosionsimul) then
end if
! *****************************************************************
! determine the deposition rate of each cell
if (sepdepositionsimul) then

do i=1,imx1
if (cv(i)>cvlimit(i) .and.absubar(i)<2./3.*fvdepo(i)) then
deporate(i)=coedepo*(1.-3./2.*absubar(i)/fvdepo(i))*(cvlimit(i)-cv(i))/cvstar*absubar(i)

! check the deporate rate to make sure it is not too large
if (abs(deporate(i)*dt)>fh(i)) deporate(i)=-fh(i)/dt
if (abs(deporate(i)*dt*rhodepo(i))>fh(i)*frho(i)) rhodepo(i)=-fh(i)*frho(i)/deporate(i)/dt

if ((frho(i)*fh(i)+deporate(i)*dt*rhodepo(i))<(rhow*(fh(i)+deporate(i)*dt))) then
deporate(i)=(rhow-frho(i))*fh(i)/(rhodepo(i)-rhow)/dt
end if


tempdebdepothick(i)=debdepothick(i)+abs(deporate(i)*dt)

!if (tempdebdepothick(i)>0.) then
!write (*,*) 'i',i,'tempdebdepothick',tempdebdepothick(i),'deporate',deporate(i)
!pause
!end if


end if

end do
!if (sepdepositionsimul) then
end if
! *****************************************************************
! determine the deposition rate of each cell when simulating the deposition of water and solid materials seperately

! *****************************************************************
! predict the debris flow density and flow depth in the predicting step
fhpredi(:)=fh(:)+(tempri(:)+erorate(:)+deporate(:))*dt+tempinflowh(:)
frhopredi(:)=(frho(:)*fh(:)+tempri(:)*dt*rhow+erorate(:)*dt*rhoero+deporate(:)*dt*rhodepo(:)+tempinflowh(:)*tempinflowrho(:))/fhpredi(:)

! *****************************************************************
where (fhpredi<=0.) fhpredi=0.
where (fhpredi<=eps) frhopredi=rhow

! out flow
where (outflow==.true.) fhpredi=0.
where (outflow==.true.) frhopredi=rhow


! calculate flow velocities and flow rates
do i=1,imx1
do ii=1,maxdirection
nq=fp(i,ii)
dt0=0.
if (nq==0) cycle
if (qq(i,ii)/=0.) cycle

! *****************************************************************
! compute the velocity and discharge using the total friction slope
if (fhpredi(i)<=tol .and. fhpredi(nq)<=tol) then
fvpredi(i,ii)=0.
qq(i,ii)=0.
qqmass(i,ii)=0.
cycle
end if
! h is the water surface elevation of cell i
! hn is the water surface elevation of cell nq
if (erosionsimul .or. sepdepositionsimul) then
hi=fhpredi(i)+ele(i)+tempinierodithick(i)+tempdebdepothick(i)
hn=fhpredi(nq)+ele(nq)+tempinierodithick(nq)+tempdebdepothick(nq)
else
hi=fhpredi(i)+ele(i)
hn=fhpredi(nq)+ele(nq)
end if
if (ii==1 .or. ii==3 .or. ii==5 .or. ii==7) then
grad=(hn-hi)/celsiz
else
grad=(hn-hi)/celsiz/2.**0.5
end if
!hbar is the average flow depth of the two cells
hbar=0.5*(fhpredi(i)+fhpredi(nq))
ybar=hbar
fybar(i,ii)=ybar

if (ybar/=0.) then 

! average value of cv
parai=(frhopredi(i)-rhow)/(rhos-rhow)
paran=(frhopredi(nq)-rhow)/(rhos-rhow)
if (parai<0.) parai=0.
if (paran<0.) paran=0.
cvbar=0.5*(parai+paran)
! average value of dynamic viscosity
if (cvbar<0.1) then
miubar=0.001+cvbar/0.1*(alpha2*exp(beta2*0.1)-0.001)
else
miubar=alpha2*exp(beta2*cvbar)
end if
! average value of equivelant manning
manningbar=0.5*(abs(manning(i))+abs(manning(nq)))
manningbar=manningbar*manningb*exp(manningm*cvbar)
! average value of debris flow density
frhobar=0.5*(frhopredi(i)+frhopredi(nq))
if (frhobar<rhow) frhobar=rhow
! average value of normal friction coefficient
cosslope=cos(atan(abs(grad)))
parai=cosslope**2.*tan(phit(zo(i)))
paran=cosslope**2.*tan(phit(zo(nq)))
normfriccoebar=0.5*(parai+paran)


if (slo(i)>0.175) then
! slope is larger than 10 degree
! use Mohr-Coulomb yield stress considering particle suspension in flume and channel
sfy=(1-cs)*cv(i)*(rhos-rhow)/frhopredi(i)*normfriccoebar
else
! use O'Brien yield stress on debris fan
sfy=alpha1*exp(beta1*cvbar)/frhobar/grav/ybar
end if


if (sfy>=abs(grad) .and. abs(fv(i,ii))<=eps) then
fvpredi(i,ii)=0.
else
sfmiu=kresis*miubar/(8.*frhobar*grav*ybar**2.)*abs(fv(i,ii))
sfmanning=manningbar**2./ybar**1.333*abs(fv(i,ii))**2.
sf=sfy+sfmiu+sfmanning

if (fv(i,ii)==0.) then
sf=sign(sf,-grad)
else
sf=sign(sf,fv(i,ii))
end if

if (ii==1) localvdiff=0.5*(fv(nq,1)+fv(i,5))
if (ii==2) localvdiff=0.5*(fv(nq,2)+fv(i,6))
if (ii==3) localvdiff=0.5*(fv(nq,3)+fv(i,7))
if (ii==4) localvdiff=0.5*(fv(nq,4)+fv(i,8))
if (ii==5) localvdiff=0.5*(fv(nq,5)+fv(i,1))
if (ii==6) localvdiff=0.5*(fv(nq,6)+fv(i,2))
if (ii==7) localvdiff=0.5*(fv(nq,7)+fv(i,3))
if (ii==8) localvdiff=0.5*(fv(nq,8)+fv(i,4))


! artificial viscosity
if (ii==1) artivis=fv(nq,1)-2.*fv(i,1)-fv(i,5)
if (ii==2) artivis=fv(nq,2)-2.*fv(i,2)-fv(i,6)
if (ii==3) artivis=fv(nq,3)-2.*fv(i,3)-fv(i,7)
if (ii==4) artivis=fv(nq,4)-2.*fv(i,4)-fv(i,8)
if (ii==5) artivis=fv(nq,5)-2.*fv(i,5)-fv(i,1)
if (ii==6) artivis=fv(nq,6)-2.*fv(i,6)-fv(i,2)
if (ii==7) artivis=fv(nq,7)-2.*fv(i,7)-fv(i,3)
if (ii==8) artivis=fv(nq,8)-2.*fv(i,8)-fv(i,4)

if (ii==1 .or. ii==3 .or. ii==5 .or. ii==7) then
dv=(-grad-sf-fv(i,ii)*localvdiff/celsiz/grav)*grav*dt-fv(i,ii)*(erorate(i)+deporate(i))*dt/ybar+0.02*abs(fhpredi(i)-fhpredi(nq))/(fhpredi(i)+fhpredi(nq))*artivis
else
dv=(-grad-sf-fv(i,ii)*localvdiff/celsiz/grav/2.**0.5)*grav*dt-fv(i,ii)*(erorate(i)+deporate(i))*dt/ybar+0.02*abs(fhpredi(i)-fhpredi(nq))/(fhpredi(i)+fhpredi(nq))*artivis
end if
fvpredi(i,ii)=dv+fv(i,ii)

! check whether the signs of fv and fvpredi are not the same
if (fv(i,ii)*fvpredi(i,ii)<0) then
dt0=-fv(i,ii)/(dv/dt)

! if the yield stress is larger than the total head gradient, fvpredi is zero
if (sfy>=abs(grad)) then
fvpredi(i,ii)=0.
else
! acceleration in the other direction
sfy=sign(sfy,-grad)
fvpredi(i,ii)=(-grad-sfy)*grav*(dt-dt0)
end if
end if

end if


fvlimit=limitfr*sqrt(grav*ybar)
if (abs(fvpredi(i,ii))>fvlimit) fvpredi(i,ii)=sign(fvlimit,fvpredi(i,ii))
vel=abs(fvpredi(i,ii))
! jude whether the time-step is too large using CFL criterion
if (ii==1 .or. ii==3 .or. ii==5 .or. ii==7) then
dttest=celsiz/(vel+sqrt(grav*ybar))
else
dttest=celsiz*2.**0.5/(vel+sqrt(grav*ybar))
end if

if (isnan(vel)) then
write (*,*) 'i',i,'ii',ii
write (*,*) 'aa',aa,'bb',bb,'cc',cc
write (*,*) 'ybar',ybar,'fhpredi(i)',fhpredi(i),'fhpredi(nq)',fhpredi(nq),'frhobar',frhobar
write (*,*) 'vel',vel
pause 'please check the vel'
end if

if (dt>dttest) then
write (*,*) 'dt>dttest'
dt=dt-dtd
if (dt<dtmin) dt=dtmin
goto 1000
end if

! estimate the debris flow density of the flux
if (fvpredi(i,ii)>=0.) then
ybar=min(fhpredi(i),hbar)
frhoflux=frhopredi(i)
else
frhoflux=frhopredi(nq)
ybar=min(fhpredi(nq),hbar)
end if

! if (ybar/=0.)
else
fvpredi(i,ii)=0.
! if (ybar/=0.)
end if

qq(i,ii)=fvpredi(i,ii)*ybar*width*(dt-dt0)
qqmass(i,ii)=frhoflux*qq(i,ii)

! computing the flux and mass flux of the cell nq to same time
if (ii==1) then
qq(nq,5)=-qq(i,ii)
qqmass(nq,5)=-qqmass(i,ii)
fvpredi(nq,5)=-fvpredi(i,ii)
fybar(nq,5)=fybar(i,ii)
elseif (ii==2) then
qq(nq,6)=-qq(i,ii)
qqmass(nq,6)=-qqmass(i,ii)
fvpredi(nq,6)=-fvpredi(i,ii)
fybar(nq,6)=fybar(i,ii)
elseif (ii==3) then
qq(nq,7)=-qq(i,ii)
qqmass(nq,7)=-qqmass(i,ii)
fvpredi(nq,7)=-fvpredi(i,ii)
fybar(nq,7)=fybar(i,ii)
elseif (ii==4) then
qq(nq,8)=-qq(i,ii)
qqmass(nq,8)=-qqmass(i,ii)
fvpredi(nq,8)=-fvpredi(i,ii)
fybar(nq,8)=fybar(i,ii)
elseif (ii==5) then
qq(nq,1)=-qq(i,ii)
qqmass(nq,1)=-qqmass(i,ii)
fvpredi(nq,1)=-fvpredi(i,ii)
fybar(nq,1)=fybar(i,ii)
elseif (ii==6) then
qq(nq,2)=-qq(i,ii)
qqmass(nq,2)=-qqmass(i,ii)
fvpredi(nq,2)=-fvpredi(i,ii)
fybar(nq,2)=fybar(i,ii)
elseif (ii==7) then
qq(nq,3)=-qq(i,ii)
qqmass(nq,3)=-qqmass(i,ii)
fvpredi(nq,3)=-fvpredi(i,ii)
fybar(nq,3)=fybar(i,ii)
elseif (ii==8) then
qq(nq,4)=-qq(i,ii)
qqmass(nq,4)=-qqmass(i,ii)
fvpredi(nq,4)=-fvpredi(i,ii)
fybar(nq,4)=fybar(i,ii)
end if
! end do ii
end do

! estimate accumulation of inflow or outflow
qnet=-(qq(i,1)+qq(i,2)+qq(i,3)+qq(i,4)+qq(i,5)+qq(i,6)+qq(i,7)+qq(i,8))
qmassnet=-(qqmass(i,1)+qqmass(i,2)+qqmass(i,3)+qqmass(i,4)+qqmass(i,5)+qqmass(i,6)+qqmass(i,7)+qqmass(i,8))
! estimate the change of flow depth because of inflow or outflow
hinflow=qnet/cellarea
fhpredi2(i)=fhpredi(i)+hinflow
frhopredi2(i)=(frhopredi(i)*fhpredi(i)*cellarea+qmassnet)/fhpredi2(i)/cellarea

if (isnan(fhpredi2(i))) then
write (*,*) 'fhpredi2',i,'is not a number'
write (*,*) 'fhpredi',fhpredi(i)
write (*,*) 'frhopredi',frhopredi(i)
write (*,*) 'hinflow',hinflow
write (*,*) 'fhpredi',fhpredi(i)
pause 'please check the fhpredi2'
end if

! if the flow depth is smaller than 0, decrease the time step
if (fhpredi2(i)<0.) then
write (*,*) 'i',i
write (*,*) 'fhpredi2<0'
write (*,*) 'dfhtest',dfhtest,'dpfhtest',dpfhtest
write (*,*) 'fhpredi',fhpredi(i),'fhpredi2',fhpredi2(i)
write (*,*) 'fybar 1 2 3 4 are', fybar(i,1),fybar(i,2),fybar(i,3),fybar(i,4)
write (*,*) 'fvpredi 1 2 3 4 are', fvpredi(i,1),fvpredi(i,2),fvpredi(i,3),fvpredi(i,4)
write (*,*) 'qq 1 2 3 4 are', qq(i,1),qq(i,2),qq(i,3),qq(i,4)
pause
dt=dt-dtd
if (dt<dtmin) dt=dtmin
goto 1000
end if

! determine whether the time step is too large using the change of flow depth
dfhtest=abs(fhpredi2(i)-fhpredi(i))
dpfhtest=abs((fhpredi2(i)-fhpredi(i))/fhpredi(i))
if (dfhtest>toldh .and. dpfhtest>toldhp) then

dt=dt-dtd
if (dt<dtmin) then
write (*,*) 'dt<dtmin'
write (*,*) 'i',i
write (*,*) 'dfhtest',dfhtest,'dpfhtest',dpfhtest
write (*,*) 'fhpredi',fhpredi(i),'fhpredi2',fhpredi2(i)
write (*,*) 'fybar 1 2 3 4 are', fybar(i,1),fybar(i,2),fybar(i,3),fybar(i,4)
write (*,*) 'fvpredi 1 2 3 4 are', fvpredi(i,1),fvpredi(i,2),fvpredi(i,3),fvpredi(i,4)
write (*,*) 'qq 1 2 3 4 are', qq(i,1),qq(i,2),qq(i,3),qq(i,4)
pause
dt=dtmin
end if
goto 1000
end if
! end do i
end do
! outflow
where (outflow==.true.) fhpredi2=0.
where (outflow==.true.) frhopredi2=rhow
where (fhpredi2<eps) frhopredi2=rhow
! end do vv=1,vvmax
end do
! *****************************************************************
! the time step goes forward successfully, the time step can be increased and go to the next time step
tnow=tnext
dt=dt+dti
ntsdeb=ntsdeb+1
write (*,*) 'nt',nt
write (*,*) 'tnow',tnow,'dt',dt

if (dt>dtmax) dt=dtmax
fh=fhpredi2
frho=frhopredi2
fv=fvpredi
inierodithick=tempinierodithick
debdepothick=tempdebdepothick
cv=(frho-rhow)/(rhos-rhow)
where (fh<eps) fh=0.
! record the maximum flow velocity of each cell
do i=1,imx1

do ii=1,maxdirection
if (abs(fv(i,ii))>maxfv(i))  maxfv(i)=abs(fv(i,ii))
if (fh(i)>maxfh(i))  maxfh(i)=fh(i)
end do

end do



! output resutls based on different option 
if (tnow>=ttout) then

! output the result at the end of the flume
if(ttout==tout) then
write (u(19),*) 'Discharge at the end of the flume (third column) unit litter**3/s'
end if

fhtemp=0.
fvtemp=0.
do i=2001,2010
fhtemp=fh(i)+fhtemp
end do
fhtemp=fhtemp/10.
fvtemp=(abs(fv(2001,5))+abs(fv(2002,5))+abs(fv(2003,5))+abs(fv(2004,5))+abs(fv(2005,5)))/5.
cvtemp=(cv(2001)+cv(2002)+cv(2003)+cv(2004)+cv(2005))/5.
write (u(19),*) ttout,cvtemp,fvtemp*fhtemp*0.1*1000

ti=tiny(param(m))
	write(stp,'(F5.1)') ttout
	  stp=adjustl(stp)
	  ! save the grid of flow depth
	  if (flowdepthsave) then 
	  tfg=0.
	    do i=1,imx1
	      tfg(i)=fh(i)
	    end do
	    outfil=trim(folder)//trim(fhfil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    write (*,*) 'ttout',ttout
	    call ssvgrd(tfg,imax,pf1,nrow,ncol,u(4),test1,param,u(19),&
            &outfil,ti,header)
	end if
	
	! save the grid of maxximum flow depth
	  if (maxflowdepthsave) then 
	  tfg=0.
	    do i=1,imx1
	      tfg(i)=maxfh(i)
	    end do
	    outfil=trim(folder)//trim(maxfhfil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    write (*,*) 'ttout',ttout
	    call ssvgrd(tfg,imax,pf1,nrow,ncol,u(4),test1,param,u(19),&
            &outfil,ti,header)
	end if
	
	! save the grid of flow velocity
	if (fvsave) then 
	  tfg=0.
	    do i=1,imx1
	      tfg(i)=0.5*(abs(fv(i,1))+abs(fv(i,2))+abs(fv(i,3))+abs(fv(i,4)))
	    end do
	    outfil=trim(folder)//trim(fvfil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    write (*,*) 'ttout',ttout
	    call ssvgrd(tfg,imax,pf1,nrow,ncol,u(4),test1,param,u(19),&
            &outfil,ti,header)
	end if
	
	! save the grid of maximum flow velocity
	if (maxfvsave) then 
	  tfg=0.
	    do i=1,imx1
	      tfg(i)=maxfv(i)
	    end do
	    outfil=trim(folder)//trim(maxfvfil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    write (*,*) 'ttout',ttout
	    call ssvgrd(tfg,imax,pf1,nrow,ncol,u(4),test1,param,u(19),&
            &outfil,ti,header)
	end if
	
	   ! save the grid of erosion depth
	if (erosionsimul .and. erodepthsave) then 
	  tfg=0.
	    do i=1,imx1
	      tfg(i)=ltstar(i)-inierodithick(i)
	    end do
	    outfil=trim(folder)//trim(erodepthfil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    write (*,*) 'ttout',ttout
	    call ssvgrd(tfg,imax,pf1,nrow,ncol,u(4),test1,param,u(19),&
            &outfil,ti,header)
	end if
	! save the grid of deposit depth when simulating water and soil deposition seperately
	if (sepdepositionsimul .and. debdepodepthsave) then 
	  tfg=0.
	    do i=1,imx1
	      tfg(i)=debdepothick(i)
	    end do
	    outfil=trim(folder)//trim(debdepodepthfil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    write (*,*) 'ttout',ttout
	    call ssvgrd(tfg,imax,pf1,nrow,ncol,u(4),test1,param,u(19),&
            &outfil,ti,header)
	end if
   ! save the grid of deposit depth when simulating water and soil deposition seperately
	if (sepdepositionsimul .and. totaldepthsave) then 
	  tfg=0.
	    do i=1,imx1
	      tfg(i)=fh(i)+debdepothick(i)
	    end do
	    outfil=trim(folder)//trim(totaldepthfil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    write (*,*) 'ttout',ttout
	    call ssvgrd(tfg,imax,pf1,nrow,ncol,u(4),test1,param,u(19),&
            &outfil,ti,header)
	end if
	
	! save the grid of volumetric sediment concentration
	if (cvsave) then 
	  tfg=0.
	    do i=1,imx1
	      tfg(i)=(frho(i)-rhow)/(rhos-rhow)
	    end do
	    outfil=trim(folder)//trim(cvfil)//trim(suffix)//'_'//trim(stp)//'.txt'
	    write (*,*) 'ttout',ttout
	    call ssvgrd(tfg,imax,pf1,nrow,ncol,u(4),test1,param,u(19),&
            &outfil,ti,header)
	end if
	
! update the output time
ttout=ttout+tout
! output resutls end if
end if
else
write (*,*) 'The time is larger than the simulation time, program ends'
! compute the total volume of debris flow mixture in the study area
do i=1,imx1
totalflowvolume=totalflowvolume+fh(i)*cellarea
totaldepositvolume=totaldepositvolume+debdepothick(i)*cellarea
end do
totalvolume=totalflowvolume+totaldepositvolume
write (*,*) 'Total flow volume is ', totalflowvolume
write (*,*) 'Total deposit volume is ', totaldepositvolume
write (*,*) 'Total volume is ', totalvolume
write (u(19),*) 'Total flow volume is ', totalflowvolume
write (u(19),*) 'Total deposit volume is ', totaldepositvolume
write (u(19),*) 'Total volume is ', totalvolume

exit
! if (tnext<=simul) then
end if
! end do i=1,maxnts
1000 continue
end